//+------------------------------------------------------------------+
//|                                       Indicator: XxRSI+CCIxX.mq4 |
//|                                 Created by JeremyXxLESSOxXLester |
//|                                                lesso88@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Created by JeremyXxLESSOxXLester"
#property link      "lesso88@gmail.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 1
#property indicator_color1 0xFFAA00
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 1
#property indicator_color2 0x0000FF
#property indicator_label2 "Sell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

extern bool X_OverSold_OverBought = false;
extern int rsi = 8;
extern double RSI_levelup = 50;
extern double RSI_leveldn = 50;
extern double arrowdistance = 4;
extern int CCI = 14;
extern double CCI_Level = 50;
datetime time_alert; //used when sending alert
extern bool Send_Email = false;
extern bool Audible_Alerts = true;
double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | XxRSI+CCIxX @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
   else if(type == "indicator")
     {
      Print(type+" | XxRSI+CCIxX @ "+Symbol()+","+Period()+" | "+message);
      if(Audible_Alerts) Alert(type+" | XxRSI+CCIxX @ "+Symbol()+","+Period()+" | "+message);
      if(Send_Email) SendMail("XxRSI+CCIxX", type+" | XxRSI+CCIxX @ "+Symbol()+","+Period()+" | "+message);
      SendNotification(type+" | XxRSI+CCIxX @ "+Symbol()+","+Period()+" | "+message);
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, 0);
   SetIndexArrow(0, 241);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, 0);
   SetIndexArrow(1, 242);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      //Indicator Buffer 1
      if(!X_OverSold_OverBought){
      if((iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) > RSI_levelup
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i+1) < RSI_levelup //Relative Strength Index crosses above fixed value
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i) > CCI_Level)
      ||(iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i)> CCI_Level 
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i+1)< CCI_Level
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) > RSI_levelup)) 
        {
         Buffer1[i] = Low[i] - arrowdistance * myPoint; //Set indicator value at Candlestick Low - fixed value
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "Buy"); time_alert = Time[0]; } //Instant alert, only once per bar
        }
      //Indicator Buffer 2
      if((iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) < RSI_leveldn
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i+1) > RSI_leveldn //Relative Strength Index crosses below fixed value
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i) < -CCI_Level)
      ||(iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i)< -CCI_Level 
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i+1)> -CCI_Level
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) < RSI_leveldn)) 
       {
         Buffer2[i] = High[i] + arrowdistance * myPoint; //Set indicator value at Candlestick High + fixed value
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "Sell"); time_alert = Time[0]; } //Instant alert, only once per bar
        }}
      else{  
      if((iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) < RSI_levelup
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i+1) > RSI_levelup //Relative Strength Index crosses above fixed value
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i) < CCI_Level)
      ||(iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i)< CCI_Level 
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i+1)> CCI_Level
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) < RSI_levelup)) 
        { 
        Buffer2[i] = High[i] + arrowdistance * myPoint; //Set indicator value at Candlestick High + fixed value
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "Sell"); time_alert = Time[0]; } //Instant alert, only once per bar
           }
      //Indicator Buffer 2
      if((iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) > RSI_leveldn
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i+1) < RSI_leveldn //Relative Strength Index crosses below fixed value
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i) > -CCI_Level)
      ||(iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i)> -CCI_Level 
      && iCCI(NULL, PERIOD_CURRENT, CCI, PRICE_TYPICAL, i+1)< -CCI_Level
      && iRSI(NULL, PERIOD_CURRENT, rsi, PRICE_CLOSE, i) > RSI_leveldn)) 
       { 
        Buffer1[i] = Low[i] - arrowdistance * myPoint; //Set indicator value at Candlestick Low - fixed value
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "Buy"); time_alert = Time[0]; } //Instant alert, only once per bar
        }}
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+